/** ,    .*/
public class A0 extends BaseAutomata
{
    /** ,    .  null       */
    private String  m_strATSName;

    /** */
    private int[]   m_digits;

    /**   */
    private int     m_intLength;
    
    /** */
    private Phone   m_phone;

    /**
    * .
    * @param p_strName   ( ).
    * @param p_phone    .
    * @param p_ctx      .
    */
    public A0(String p_strName, Phone p_phone, Context p_ctx)
    {
        super(p_strName, p_ctx);

        m_strStateNames = new String[10];
        m_strEventNames = new String[25];
        m_strVarNames = new String[20];
        m_strActionNames = new String[30];

        int i;
        for(i = 0; i < 10; i++) m_strStateNames[i] =  ctx.getParameter("A0.y" + i);
        for(i = 0; i < 25; i++) m_strEventNames[i] =  ctx.getParameter("A0.e" + i);
        for(i = 0; i < 20; i++) m_strVarNames[i] =    ctx.getParameter("A0.x" + i);
        for(i = 0; i < 30; i++) m_strActionNames[i] = ctx.getParameter("A0.z" + i);

        m_intDelay = Integer.parseInt(ctx.getParameter("Delay") != null ? ctx.getParameter("Delay"): "10");

        m_digits        = new int[10];
        m_intLength     = 0;
        m_phone         = p_phone;
        m_strATSName    = null;

        stateChanged(0);
    }

    
    protected void caseBlock(int p_Event) throws Exception
    {
        int e = p_Event;
        int yOld = y;

        switch (y)
        {
            
    case 0:
        if    (e == 24)    {z(9); y=7;}
        
        else if    (e == 2)    {z(6);A1(2); y=3;}
        
        else if    (e == 10)    {z(10);z(20); y=1;}
        
        else if    (e == 11)    {z(11);z(21); y=1;}
        
        else if    (e == 12)    {z(12);z(22); y=1;}
        
        else if    (e == 13)    {z(13);z(23); y=1;}
        
        else if    (e == 14)    {z(14);z(24); y=1;}
        
        else if    (e == 15)    {z(15);z(25); y=1;}
        
        else if    (e == 16)    {z(16);z(26); y=1;}
        
        else if    (e == 17)    {z(17);z(27); y=1;}
        
        else if    (e == 18)    {z(18);z(28); y=1;}
        
        else if    (e == 19)    {z(19);z(29); y=1;}
        
        break;

    case 1:
        if    (e == 2)    {z(6);A1(2);A0(0); y=2;}
        
        else if    (e == 24)    {z(4);z(5);z(9); y=7;}
        
        else if    ((e == 3)||(e == 4))    {z(4);z(5); y=0;}
        
        else if    (e == 10)    {z(10);z(20); y=1;}
        
        else if    (e == 11)    {z(11);z(21); y=1;}
        
        else if    (e == 12)    {z(12);z(22); y=1;}
        
        else if    (e == 13)    {z(13);z(23); y=1;}
        
        else if    (e == 14)    {z(14);z(24); y=1;}
        
        else if    (e == 15)    {z(15);z(25); y=1;}
        
        else if    (e == 16)    {z(16);z(26); y=1;}
        
        else if    (e == 17)    {z(17);z(27); y=1;}
        
        else if    (e == 18)    {z(18);z(28); y=1;}
        
        else if    (e == 19)    {z(19);z(29); y=1;}
        
        break;

    case 2:
        if    (e == 4)    {A0(3);A0(2); y=3;}
        
        else if    (!(x(2)))    { y=3;}
        
        else if    (e == 3)    {z(4);z(5);A1(3);z(7); y=0;}
        
        else if    ((x(2))&&(x(10)))    {A1(10);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(11)))    {A1(11);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(12)))    {A1(12);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(13)))    {A1(13);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(14)))    {A1(14);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(15)))    {A1(15);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(16)))    {A1(16);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(17)))    {A1(17);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(18)))    {A1(18);z(3);A0(0); y=2;}
        
        else if    ((x(2))&&(x(19)))    {A1(19);z(3);A0(0); y=2;}
        
        break;

    case 3:
        if    (e == 22)    { y=4;}
        
        else if    (e == 10)    {A1(10);z(20); y=3;}
        
        else if    (e == 11)    {A1(11);z(21); y=3;}
        
        else if    (e == 12)    {A1(12);z(22); y=3;}
        
        else if    (e == 13)    {A1(13);z(23); y=3;}
        
        else if    (e == 14)    {A1(14);z(24); y=3;}
        
        else if    (e == 15)    {A1(15);z(25); y=3;}
        
        else if    (e == 16)    {A1(16);z(26); y=3;}
        
        else if    (e == 17)    {A1(17);z(27); y=3;}
        
        else if    (e == 18)    {A1(18);z(28); y=3;}
        
        else if    (e == 19)    {A1(19);z(29); y=3;}
        
        else if    (e == 4)    {A0(3);A0(2); y=3;}
        
        else if    (e == 3)    {z(4);z(5);A1(3);z(7); y=0;}
        
        else if    (e == 21)    { y=5;}
        
        break;

    case 4:
        if    (e == 4)    {A0(3);A0(2); y=3;}
        
        else if    (e == 3)    {z(4);z(5);A1(3);z(7); y=0;}
        
        break;

    case 5:
        if    (e == 4)    {A0(3);A0(2); y=3;}
        
        else if    (e == 23)    { y=6;}
        
        else if    (e == 3)    {z(4);z(5);A1(3);z(7); y=0;}
        
        break;

    case 6:
        if    (e == 22)    { y=4;}
        
        else if    (e == 4)    {A0(3);A0(2); y=3;}
        
        else if    (e == 3)    {z(4);z(5);A1(3);z(7); y=0;}
        
        break;

    case 7:
        if    (e == 22)    { y=0;}
        
        else if    (e == 2)    {z(8);A1(22); y=8;}
        
        break;

    case 8:
        if    (e == 3)    {A1(23);z(7); y=0;}
        
        else if    (e == 22)    { y=9;}
        
        break;

    case 9:
        if    (e == 3)    {A1(23);z(7); y=0;}
        
        break;


        }
        
        if (y == yOld) return;
        switch (y)
        {
            
        }
    }
    


    protected void stateChanged(int p_intOldState)
    {
        boolean b = true;
        if ((y == 0) || (y == 1) || (y == 7)) b = false;
        m_phone.setState(y, m_strStateNames[y], b);
    }
    
    /**
    *        .
    *   ,    .     
    *     .
    * @param x .
    */
    private void z1X(int x)
    {
        if (m_intLength < 9)
        {
            m_digits[m_intLength] = x;
            m_intLength = m_intLength + 1;
        };
    }

    /**
    *    .
    * @param x .
    */
    private void z2X(int x)
    {
        m_phone.displayAddString("" + x);
    }

    /**        .*/
    protected void z3()
    {
        for(int i = 1; i < m_intLength; i++)
        {
            m_digits[i - 1] = m_digits[i];
        }
        m_intLength = m_intLength - 1;
    }

    /**     .*/
    protected void z4()
    {
        m_intLength = 0;
    }

    /** .*/
    protected void z5()
    {
        m_phone.displayReset();
    }

    /** .*/
    protected void z6()
    {
        m_strATSName = ctx.getFreeATS();
    }

    /** .*/
    protected void z7() throws Exception
    {
        ctx.setATSFree(m_strATSName);
        m_strATSName = null;
    }
    
    /**   */
    protected void z8() throws Exception
    {
        ctx.occupyATS(m_strATSName);
    }
    
    /**  */
    protected void z9() throws Exception
    {
        m_strATSName = getCaller();
    }
    
    /**{@link #z1X(int x)}, x = 0*/
    protected void z10() {z1X(0);}
    /**{@link #z1X(int x)}, x = 1*/
    protected void z11() {z1X(1);}
    /**{@link #z1X(int x)}, x = 2*/
    protected void z12() {z1X(2);}
    /**{@link #z1X(int x)}, x = 3*/
    protected void z13() {z1X(3);}
    /**{@link #z1X(int x)}, x = 4*/
    protected void z14() {z1X(4);}
    /**{@link #z1X(int x)}, x = 5*/
    protected void z15() {z1X(5);}
    /**{@link #z1X(int x)}, x = 6*/
    protected void z16() {z1X(6);}
    /**{@link #z1X(int x)}, x = 7*/
    protected void z17() {z1X(7);}
    /**{@link #z1X(int x)}, x = 8*/
    protected void z18() {z1X(8);}
    /**{@link #z1X(int x)}, x = 9*/
    protected void z19() {z1X(9);}
    
    /**{@link #z2X(int x)}, x = 0*/
    protected void z20() {z2X(0);}
    /**{@link #z2X(int x)}, x = 1*/
    protected void z21() {z2X(1);}
    /**{@link #z2X(int x)}, x = 2*/
    protected void z22() {z2X(2);}
    /**{@link #z2X(int x)}, x = 3*/
    protected void z23() {z2X(3);}
    /**{@link #z2X(int x)}, x = 4*/
    protected void z24() {z2X(4);}
    /**{@link #z2X(int x)}, x = 5*/
    protected void z25() {z2X(5);}
    /**{@link #z2X(int x)}, x = 6*/
    protected void z26() {z2X(6);}
    /**{@link #z2X(int x)}, x = 7*/
    protected void z27() {z2X(7);}
    /**{@link #z2X(int x)}, x = 8*/
    protected void z28() {z2X(8);}
    /**{@link #z2X(int x)}, x = 9*/
    protected void z29() {z2X(9);}


    /**
    *   -  x
    * @param x -  .
    * @return       x.
    */
    private boolean x1X(int x)
    {
        return (m_intLength >= 1) && (m_digits[0] == x);
    }

    /**
    *    .
    * @return       .
    */
    protected boolean x2()
    {
        return m_intLength >= 1;
    }
    
    /**{@link #x1X(int x)}, x = 0*/
    protected boolean x10() {return x1X(0);}
    /**{@link #x1X(int x)}, x = 1*/
    protected boolean x11() {return x1X(1);}
    /**{@link #x1X(int x)}, x = 2*/
    protected boolean x12() {return x1X(2);}
    /**{@link #x1X(int x)}, x = 3*/
    protected boolean x13() {return x1X(3);}
    /**{@link #x1X(int x)}, x = 4*/
    protected boolean x14() {return x1X(4);}
    /**{@link #x1X(int x)}, x = 5*/
    protected boolean x15() {return x1X(5);}
    /**{@link #x1X(int x)}, x = 6*/
    protected boolean x16() {return x1X(6);}
    /**{@link #x1X(int x)}, x = 7*/
    protected boolean x17() {return x1X(7);}
    /**{@link #x1X(int x)}, x = 8*/
    protected boolean x18() {return x1X(8);}
    /**{@link #x1X(int x)}, x = 9*/
    protected boolean x19() {return x1X(9);}

    
    /**
    *  {@link A0}   e.
    * @param e .
    */
    private void A0(int e)
    {
        this.A(new BaseEvent(e, getName()));
    }
    
    /**
    *  {@link A1}   e.
    * @param e .
    */
    private void A1(int e)
    {
        ctx.getAutomata(m_strATSName).A(new BaseEvent(e, getName()));
    }
}