import java.awt.*;
import java.awt.event.*;

/**
*  .           .
*/
public class ATS extends Panel
{
    /** .*/
    private Label m_lblState;
    /**    .*/
    private Label m_lblNumber;

    /** ,    .*/
    private String m_strAutomataName;


    /** .*/
    private Context ctx;


    /**
    * .
    * @param p_strAutomataName  ,    .
    * @param p_ctx              .
    */
    public ATS(String p_strAutomataName, Context p_ctx)
    {
        super(new BorderLayout(5, 5));

        setBackground(Color.black);

        m_strAutomataName = p_strAutomataName;
        ctx = p_ctx;

        initControls();
    }

    
    /**
    *     .
    */
    private void initControls()
    {
        m_lblState = new Label("");
        m_lblState.setBackground(Color.lightGray);
        m_lblState.setSize(200, 20);

        m_lblNumber = new Label("");
        m_lblNumber.setBackground(Color.lightGray);
        m_lblNumber.setSize(200, 20);

        add(m_lblState, BorderLayout.NORTH);
        add(m_lblNumber, BorderLayout.CENTER);
    }

    
    /**
    *     .
    * @param p_stateName   .
    */
    public void setState(String p_stateName)
    {
        m_lblState.setText(p_stateName);
    }


    /**
    *         .
    * @param p_strNumber     .
    */
    public void setNumber(String p_strNumber)
    {
        m_lblNumber.setText(p_strNumber);
    }

}