import java.text.*;
import java.util.*;

/**
*   .
*/
public class Logger {

    /** .     */
    private String m_strName;
    
    /**
    * .
    * @param p_strName  .     .
    */
    public Logger(String p_strName)
    {
        m_strName = p_strName;
    }

    /**
    *  .
    * @param p_strMessage    .
    * @param p_intLevel      .    
    * @param p_strSource    .
    */
    public void log(String p_strMessage, String p_strSource, int p_intLevel)
    {
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yy hh.mm.S");

        String strTmp = sdf.format(new Date()) + "\t" + p_strSource + "\t:\t";
        for(int i = 0; i < p_intLevel; i++) { strTmp = strTmp + "\t"; }

        System.out.print(strTmp + p_strMessage + "\n");
    }

    /**
    *  .   0,    -  .
    * @param p_strMessage    .
    */
    public void log(String p_strMessage) 
    { 
        log(p_strMessage, "", 0); 
    }

    /**
    *  .    0.
    * @param p_strMessage    .
    * @param p_strSource    .
    */
    public void log(String p_strMessage, String p_strSource) 
    { 
        log(p_strMessage, p_strSource, 0); 
    }
}