import java.awt.*;
import java.applet.*;

/** .*/
public class PhoneNet extends Applet
{
    /** */
    Phone phone1;

    /** */
    Phone phone2;
    
    /**       */
    public void init()
    {
        Context ctx;

        super.init();
        this.setLayout(new BorderLayout(10, 0));

        ctx = new Context(this);

        String phone1Name = ctx.getParameter("Phone1Name");
        String phone2Name = ctx.getParameter("Phone2Name");

        ATS ats1, ats2;
        String ats1Name = ctx.getParameter("ATS1Name");
        String ats2Name = ctx.getParameter("ATS2Name");

        phone1 = new Phone(phone1Name, ctx);
        phone2 = new Phone(phone2Name, ctx);
        ats1 = new ATS(ats1Name, ctx);                     
        ats2 = new ATS(ats2Name, ctx);

        ctx.addAutomata(new A0(phone1Name, phone1, ctx));
        ctx.addAutomata(new A0(phone2Name, phone2, ctx));
        ctx.addAutomata(new A1(ats1Name, ats1, ctx));
        ctx.addAutomata(new A1(ats2Name, ats2, ctx));


        add(phone1, BorderLayout.EAST);
        add(phone2, BorderLayout.WEST);
        Panel pnlATS = new Panel(new GridLayout(4, 1, 0, 10));
        pnlATS.add(ats2);
        pnlATS.add(ats1);

        add(pnlATS, BorderLayout.CENTER);
    }
}